/*********************************************************************
 *	gWp@ȈՃj^[ :: gW}U[{[h̃eXg.
 *********************************************************************
 */
#include "monit.h"
#include <string.h>
#include "sci.h"


/*
	SC1602BSLB	tW[̐.
	---------------------------------
	ڑ:LCD_D
		bit7	NC
		bit6	NC
		bit5	LCD E	:Enable Signal(H->L)
		bit4	LCD RS	:Register Select(L:instruction,H:Data)
		bit3	LCD D7
		bit2	LCD D6	
		bit1	LCD D5	
		bit0	LCD D4	
	R}h:			RS R/W DATA
		Clear Display | 0  0   0000_0001
		Cursor Home   | 0  0   0000_001*
		Entry Mode Set| 0  0   0000_01DS | D=Direction(1=inc) ,S=with display shift
		Display on/off| 0  0   0000_1DCB | D=disp on ,C=cursor on,B=cursor blink
		Cursor Display| 0  0   0001_SR** | S=display shift,R=shift to the right
		Function set  | 0  0   001D_NF** | D=8bit data length,N=2 lines,F=10dot/7dot
		CGRAM Address | 0  0   01 < ACG >| Set the CGRAM Address
		DDRAM Address | 0  0   1 < ADD  >| Set the DDRAM Address
		Address Read  | 0  1   B <  AC  >| B=Busy flag AC= read address
        CGRAM/DDRAM   | 1 R/W  < DATA   >| Data read or write.

*/

//=== t|[giój.
#define	LCD_D	P3.DR.BYTE			//t̃f[^|[g.
#define	E_SIG	P3.DR.BIT.B5		//t̂dM.
#define	RS		P3.DR.BIT.B4		//qrM.

//=== crv  ǂݎ|[gíj.
#define	P2DR	P2.DR.BYTE			//;|[g2f[^WX^ 8P-DIP(S5)

//=== vbVrvǂݎ|[gíj. bit[7..4]
#define	P4DR	P4.DR.BYTE			//;|[g4f[^WX^

//=== kdc|[g.iój.
#define	P5DR	P5.DR.BYTE			//;|[g5f[^WX^
#define	LED1	P5.DR.BIT.B0		//;LED1
#define	LED2	P5.DR.BIT.B1		//;LED2


//=== crv  ǂݎ茋. ==P2DR
static uchar sw_d5;

//=== vbVrvǂݎ茋. ==P4DR
static uchar sw_d;

//=== kbc\e.
static uchar lcd_buf[16 * 2];	//PU~Qs.

//=== kbc\ȅf[^.
const uchar init_str[]= "AKI-H8 \xcf\xbb\xde\xb0\xce\xde\xb0\xc4\xde"	// nJNJi.
						"1111 11111111   ";
//						|0123456789012345|

//=================================================
//	Sȓ҂
//=================================================
void wait_4ms(void)
{
	Wait_usec(4000);
}


//=================================================
//	50ʂȓ҂
//=================================================
void wait_us(void)
{
	Wait_usec(50);
}


//=================================================
//	
//=================================================
void lcd_out8(uchar c)
{
	RS = 0;		//qrM.

	E_SIG = 1;		//t̂dMZbg.
	LCD_D = c;
	wait_us();

	E_SIG = 0;		//t̂dMNA.
	wait_us();

	wait_4ms();
}

//=================================================
//	
//=================================================
void lcd_out4(uchar c)
{
	//;--ʂSrbgo
	E_SIG = 1;		//t̂dMZbg.
	LCD_D = (LCD_D & 0xf0) | (c>>4);
	wait_us();

	E_SIG = 0;		//t̂dMNA.
	wait_us();

	//;--ʂSrbgo
	E_SIG = 1;		//t̂dMZbg.
	LCD_D = (LCD_D & 0xf0) | (c & 0x0f);
	wait_us();
	E_SIG = 0;		//t̂dMNA.
	wait_us();
}


//=================================================
//	
//=================================================
void lcd_out40(uchar c)
{
	RS = 0;		//qrM.

	lcd_out4(c);
	wait_4ms();
}


//=================================================
//	kbc̏ݒ
//=================================================
void lcd_init(void)
{
	int i;
	for(i=0;i<3;i++) {
		lcd_out8(0x23);	// 0010_0011 kbct@NVZbg1,2,3
	}
	lcd_out8(0x22);	// 0010_0010 t@NVZbg.
	
	//;-----ݒ----
	lcd_out40(0x28);	// 0010_1000 t@NVZbg.
//	lcd_out40(0x0e);	// 0000_1110 \nm.CURSOR ON
	lcd_out40(0x0c);	// 0000_1110 \nm.
	lcd_out40(0x06);	// 0000_0110 Gg[[h.
	//;-----ݒI----
}

//=================================================
//	vbVrv̒lkbcobt@ɔf.
//=================================================
void pushsw_disp(uchar d)
{
	uchar i,c;
	sw_d = d;
	for(i=0;i<4;i++) {
		if(d & 0x10) c = '1';
		else         c = '0';
		lcd_buf[16+i]=c;
		d >>= 1;
	}
}
//=================================================
//	vbVrv̒lkdc_ɔf.
//=================================================
void led_disp(uchar d)
{
	if(d & 0x40) {	//S3̏Ԃ`FbN
		LED1 = 0;	//ĂȂ̂ŏ.
	}else{
		LED1 = 1;	//Ă̂œ_.
	}

	if(d & 0x80) {	//S4̏Ԃ`FbN
		LED2 = 0;	//ĂȂ̂ŏ.
	}else{
		LED2 = 1;	//Ă̂œ_.
	}
}

//=================================================
//	crv̒lkbcobt@ɔf.
//=================================================
void dipsw_disp(uchar d)
{
	uchar i,c;
	sw_d5 = d;
	for(i=0;i<8;i++) {
		if(d & 0x01) c = '1';
		else         c = '0';
		lcd_buf[16+5+i]=c;
		d >>= 1;		
	}	
}

//=================================================
//	to		PUQs
//=================================================
void lcd_disp(void)
{
	uchar i,c;

	lcd_out40(0x02);	// 0000_0010 J[\z[.
	for(i=0;i<16;i++) {
		c = lcd_buf[i];
		LCD_D = c ;			// f[^RAMɂB
		RS    = 1 ;			// f[^Ȃ̂RSPɂB
		lcd_out4(c);
		RS    = 0 ;			// RS0ɂB
	}
	lcd_out40(0xc0);	// 1100_0000 J[\Qsڂɂ.
	for(i=0;i<16;i++) {
		c = lcd_buf[16+i];
		LCD_D = c ;			// f[^RAMɂB
		RS    = 1 ;			// f[^Ȃ̂RSPɂB
		lcd_out4(c);
		RS    = 0 ;			// RS0ɂB
	}
}

//=================================================
//	to::C[v.
//=================================================
void lcd_proc(void)
{
	uchar c;

	sw_d=0;
	sw_d5=0;

	while(1) {
		c = P4DR; if(c != sw_d)  pushsw_disp(c);
		c = P2DR; if(c != sw_d5) dipsw_disp(c);
		lcd_disp();
		led_disp(sw_d);
	}
}


//===========================================================
//	to̓eXg:: crvVnɂƂ̂݋N
//===========================================================
void lcd_test(void)
{
	uchar c;

	//;-----tʕ\-----
	lcd_init();
	lcd_out40(0x01);	// 0000_0001 \NA.
	memcpy(lcd_buf,init_str,32);
	lcd_disp();

	c = P2DR; 
	if((c & 0x40)==0) lcd_proc();	// DIPSW-7 OnȂLCDeXg.	
}


