/*********************************************************************
 *	ȣԣѡʰץ˥.
 *********************************************************************
 */
#include "monit.h"
#include "sci.h"

#define	sci_putc(c)			putDebugChar(c)
#define	sci_async_getc()	getDebugCharAsync()

#define EINT() asm volatile ("andc.b #0x7f, ccr")
#define DINT() asm volatile ("orc.b  #0x80, ccr")

static	int	 LED_tick;
#define	MAX_INPUT	80

#if	0
static	char  input_buf[MAX_INPUT];
#else

//	꡼Τ gdbstub.c ȶ.
extern	char  	  remcomInBuffer[];	// 80Хɬ.
#define	input_buf remcomInBuffer

#endif


static	uchar input_cnt = 0;
void lcd_test(void);

/*********************************************************************
 *	˥ޥɲϤȼ¹.
 *********************************************************************
 */
int  cmdMonit(char *buf);

#ifdef	_TINY

#define	LED_off()		IO.PDR8.BYTE=(0x1f)
#define	LED_on()		IO.PDR8.BYTE=(0x00)

/*********************************************************************
 *	ɡ ݡȤν.
 *********************************************************************
 */
void monitor_init_io(void)
{
	// Port Mode Register
	IO.PMR1.BYTE  = 0x0E;	// P22/TxD=1

	// I/O Port2
	IO.PCR2       = 0xFD;	// P22/TxD = out P21/RxD = in
	IO.PDR2.BYTE  = 0xFC;	// P22/TxD = 1

	// I/O Port8
	IO.PCR8		  = 0x1f;	// P81,P82 => out
}
#else

#define	LED_off()		P5.DR.BIT.B0=1
#define	LED_on()		P5.DR.BIT.B0=0

void monitor_init_io(void)
{
	P2.DDR = 0;			//ݡ2Ϥ(S5)
	P2.PCR.BYTE = 0xff;	//ݡ2ץ륢åפ.

	P3.DDR = 0xff;		//ݡ3Ϥ.

	P4.DDR = 0;			//ݡ4Ϥ.
	P4.PCR.BYTE = 0xff;	//ݡ4ץ륢åפ.

	P5.DDR = 0xff;		//ݡ5Ϥ.

	P5.DR.BIT.B1=0;		// LED1 .
}

#endif

void sci_echo(char c)
{
	sci_putc(c);
	if(c=='\r') {		// CR ʤ
		sci_putc('\n');	// LF 䴰.
	}
}


void Wait_msec(int msec)
{
	int i;
	for(i=0;i<msec;i++) {
		Wait_usec(1000);
	}
}

/*********************************************************************
 *	̣ţĤǤ.
 *********************************************************************
 */
void LED_task(void)
{
	LED_tick++;
	if((LED_tick & 0xffff)!=0) return;

	if( LED_tick & 0x10000 ) {
		LED_on();
	}else{
		LED_off();
	}
}


/*********************************************************************
 *	Ϥμ¹.
 *********************************************************************
 * ۤΰ
 *
 *	ϥХåե 		 : input_buf[]
 *	ϺѤߤʸ : input_cnt
 *
 * ͡
 *
 *	Ϥλ '\r' ֤.
 *	ʸ̵뤤ӾΤȤ -1 ֤.
 */
int	getline_task(void)
{
	short c = sci_async_getc();
	if(c < 0) return c;				//̵.

	sci_echo(c);	// ꥢ˥.

	// Ԥʤ顢뤹.
	if( c == '\r' ) {
		input_buf[input_cnt] = 0;
		input_cnt = 0;
		return c;			// .
	}

	// £(DEL)ʤ顢ʸ.
	if((c == 0x08 )||(c== 0x7f)) {
		if(input_cnt!=0) input_cnt--;
		return -1;
	}

	// CLR ʤ顢ʸ.
	if(c == 0x0c ) {
		input_cnt = 0;
		return -1;
	}

	// ԰ʳʸʤ ԥХåեˤ.
	if(	input_cnt < MAX_INPUT ) {
		input_buf[input_cnt++] = c;
	}

	return -1;
}
/*********************************************************************
 *	ϤԤʤ.
 *********************************************************************
 */
char *get_line(char *s)
{
	sci_puts(s);
	while( getline_task() < 0) ;	//Ϥλ >=0
	return input_buf;
}

/*********************************************************************
 *	ϤԤʤMonitorޥɤȤߤʤƼ¹Ԥ.
 *********************************************************************
 */
int	Monitor_task(void)
{
	int rc = 0;

	if( getline_task() >= 0) {	//Ϥλ >=0
		if(input_buf[0]) {
			rc = cmdMonit(input_buf);	// quitλ 1 ֤.
		}
		sci_puts("\r:");
	}

	return rc;
}

char getDebugChar2(void)
{
	int ch;
	while(1) {
		ch = getDebugCharAsync();
		if(ch>=0) return ch;
		LED_task();
	}
}

void getMonitorCmd(void)
{
	int rc;
	do {
		LED_task();
		rc = Monitor_task();
	}while(rc == 0);
}

/*********************************************************************
 *	ᥤ.
 *********************************************************************
 */
int	monitor_main()
{
	DINT();
	monitor_init_io();
	lcd_test();
	Wait_msec(500);
	sci_Init(19200);
	EINT();

	while (1) {
		LED_task();
		Monitor_task();
	}
	return 0;
}
/*********************************************************************
 *
 *********************************************************************
 */
