/* Default linker script, for normal executables */
/* OUTPUT_FORMAT("coff-h8300") */
OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300hn)
ENTRY("_start")
MEMORY
{
	vectors : o = 0x0000, l = 0x100
	rom     : o = 0x0100, l = 0x7f00
	ram     : o = 0xf780, l = 0x0800
	/* The stack starts at the top of main ram.  */
	topram  : o = 0xff00, l = 0x80
	/* At the very top of the address space is the 8-bit area.  */
	eight   : o = 0xff00, l = 0x100
}
SECTIONS
{
.vectors :
	{
	  /* Use something like this to place a specific
	     function's address into the vector table.
	     SHORT (ABSOLUTE (_foobar)).  */
	  *(.vectors)
	}  > vectors
.text :
	{
	  *(.rodata)
      *(.rodata.str*)
	  *(.text)
	  *(.strings)
   	   _etext = . ;
	}  > rom
.tors :
	{
	  ___ctors = . ;
	  *(.ctors)
	  ___ctors_end = . ;
	  ___dtors = . ;
	  *(.dtors)
	  ___dtors_end = . ;
	} > rom
    __idata_start = .; 
.data :
	AT (ADDR(.tors)+SIZEOF(.tors)) {
      __data_start = .; 
	  *(.data)
	  *(.tiny)
	   _edata = . ;
	}  > ram
    __idata_end = __idata_start + SIZEOF(.data);

	__bss_start = . ;
.bss :
	{
	  *(.bss)
	  *(COMMON)
	   __bss_end   = . ;
	}  >ram
.stack :
	{
	  __stack_start = .;
	  *(.stack)
	}  > topram
    __stack_end = .;
.eight :
	{
	  *(.eight)
	}  > eight
.stab 0 (NOLOAD) :
	{
	  [ .stab ]
	}
.stabstr 0 (NOLOAD) :
	{
	  [ .stabstr ]
	}
}
